﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Windows;
using Autodesk.AutoCAD.Geometry;

[assembly: CommandClass(typeof(AcedCmdTest.MyClass))]

namespace AcedCmdTest
{
	
	/// <summary>
	/// Description of MyClass.
	/// </summary>
	public class MyClass
	{
		PaletteSet paletteSet;
		
		[DllImport("acad.exe", CallingConvention = CallingConvention.Cdecl, EntryPoint="acedCmd")]
		extern static int acedCmd(IntPtr pResbuf);

      [DllImport("acad.exe", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode, EntryPoint = "?acedPostCommand@@YAHPB_W@Z")]
      public extern static int acedPostCommand32(string CommandStr);
      [DllImport("acad.exe", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Unicode, EntryPoint = "?acedPostCommand@@YAHPEB_W@Z")]
      public extern static int acedPostCommand64(string CommandStr);
		
		public unsafe static int Command(ResultBuffer args)
		{
			if( !Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.IsApplicationContext )
				return acedCmd((IntPtr) args.UnmanagedObject.ToPointer());
			else
				return 0;
		}
		
		[CommandMethod("method1", CommandFlags.Redraw | CommandFlags.Session | CommandFlags.UsePickSet)]
		public void method1()
		{
			if (paletteSet == null)
			{
				paletteSet = new PaletteSet("acedcmdtest-paletteset");
				paletteSet.Add("default-control", new MyUserControl());
			}
			
			paletteSet.Visible = true;
		}
		
		// Klappt
		[CommandMethod("method2")]
		public void method2()
		{
         acedPostCommand32("_CIRCLE 2,2,0 4");
		}
		
	}
}